kcapi_cipher_encrypt
Prev | Synchronous Symmetric Cipher API - One Shot | Next

## Name

kcapi_cipher_encrypt — encrypt data (synchronous one shot)

## Synopsis

`int32_t kcapi_cipher_encrypt (` | struct kcapi_handle * handle,
| const uint8_t * in,
| uint32_t inlen,
| const uint8_t * iv,
| uint8_t * out,
| uint32_t outlen,
| int access`)`;

## Arguments

`handle`

  [in] cipher handle

`in`

  [in] plaintext data buffer

`inlen`

  [in] length of in buffer

`iv`

  [in] IV to be used for cipher operation

`out`

  [out] ciphertext data buffer

`outlen`

  [in] length of out buffer

`access`

  [in] kernel access type (KCAPI_ACCESS_HEURISTIC - use internal heuristic for fastest kernel access; KCAPI_ACCESS_VMSPLICE - use vmsplice access; KCAPI_ACCESS_SENDMSG - sendmsg access)

## Description

It is perfectly legal to use the same buffer as the plaintext and ciphertext pointers. That would mean that after the encryption operation, the plaintext is overwritten with the ciphertext.

The memory should be aligned at the page boundary using posix_memalign(sysconf(_SC_PAGESIZE)), If it is not aligned at the page boundary, the vmsplice call may not send all data to the kernel.

The IV buffer must be exactly `kcapi_cipher_ivsize` bytes in size.

`return` number of bytes encrypted upon success; a negative errno-style error code if an error occurred

Prev | Up | Next
Synchronous Symmetric Cipher API - One Shot | Home | kcapi_cipher_decrypt